#!/usr/bin/gnuplot

set encoding iso_8859_1
set terminal postscript eps enhanced
set notitle
set xlabel "Array Size (log_{10})"
set ylabel "Execution Time (log_{10})"
set output "./scripts/result_seq.eps"

set key top left
set style line 1 lt 1 lw 3
set style line 2 lt 7 lw 3
set style line 3 lt 2 lw 3
set style line 4 lt 1 lw 1
set style line 5 lt 5 lw 3
set style function lines

set logscale xy 10

plot './scripts/result_seq.csv' using 1:3 with lines linestyle 1 title "sequential", \
     './scripts/result_seq.csv' using 1:5 with lines linestyle 3 title "tmp+openmp", \
     './scripts/result_seq.csv' using 1:7 with lines linestyle 4 title "tmp+thread"

quit

